/*
**  Source file for blobdetect. (c) 2004 Per-Erik Forssen
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**  
**  See the file COPYING for details.
**
*/
#ifndef __REGION_IMAGE
#define __REGION_IMAGE

#include "image_buffer.h"

int propagate_regions(ibuffer *bf_labelim1,ibuffer *bf_labelim2,
		      buffer *bf_imk,ibuffer *bf_imc,buffer *bf_pvec,
		      fpnum dmax2);

void find_new_seeds(ibuffer *bf_labelim,buffer *bf_imk,
		    ibuffer *bf_imc,buffer *bf_pvec1,
		    buffer *bf_pvec2,int regions,int new_seeds);

void propagate_regions_cnt(ibuffer *bf_labelim1,ibuffer *bf_labelim2,
			   buffer *bf_imk,ibuffer *bf_imc,buffer *bf_pvec,
			   ibuffer *bf_cntl,fpnum dmax2);

void expand_regions_cnt(ibuffer *bf_labelim0,ibuffer *bf_labelim1,
			buffer *bf_imk,ibuffer *bf_imc,buffer *bf_pvec,
			ibuffer *bf_cntl,fpnum dmax2);

void compute_moments(ibuffer *bf_labelim,buffer *bf_image,
		     buffer *bf_pvec,buffer *bf_mvec);

void labelim_compact(ibuffer *bf_labelim,ibuffer *bf_out_ind);

#endif /* __REGION_IMAGE */
